﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


namespace crossword
{
    class Program
    {
        static void Main(string[] args)
        {
            System.Diagnostics.Stopwatch timer=new System.Diagnostics.Stopwatch();
            timer.Start();
            Crossword.MyServiceClient client = new Crossword.MyServiceClient();
            
            int n=0;
            using (StreamReader sr = new StreamReader("crossword.in"))
            {             
                String line = sr.ReadLine();
                n = Convert.ToInt32(line);
            }
     
            client.Init(n);
            int R = client.getRowCount();
            int C = client.getColumnCount();
            int Q = client.getQueryCount();
           
            Char [] f={};
            string[] sss = client.getField();
            Char[,] F = new Char[R, C];
            for(int i = 0; i < R; i++)
            {
                f = sss[i].ToCharArray();
                for(int j=0; j<f.Length; j++) F[i,j] = f[j];
            }
            int err = 0;

            if (C > R)
            {
                for (int e = 1; e <= Q; e++)
                {
                    int r = 0, vr = 0, c = 0, vc = 0, v = 0, l = 0, ok = 0, m = 55;
                    string w = client.nextWord();
                    int lw = w.Length;
                    for (int i = 0; i < R; i++)
                    {
                        for (int j = 0; j < C; j++)
                        {
                            if (F[i, j] != '0')
                            {
                                if (v == 0) continue;
                                if (l < lw) { l = 0; continue; }
                                if (l < m) { m = l; r = vr; c = vc; v = 0; ok++; } l = 0;
                            }
                            else
                            {
                                if (v == 0) { vr = i; vc = j; v++; }
                                l++;
                            }
                        }
                        if (l < m && l >= lw) { m = l; r = vr; c = vc; ok++; }
                        v = 0; l = 0;
                    }
                    if (ok > 0)
                    {
                        for (int j = 0; j < lw; j++)
                        {
                            F[r, c + j] = w[j];
                        }
                    }
                    else err++;
                    client.placeWord(r, c, false);
                    if (timer.ElapsedMilliseconds > 9800) break;
                    if (err == 1) break;
                }
                long time = 0;
                client.EndGame(out time);
            }
            else
            {
                for (int e = 1; e <= Q; e++)
                {
                    int r = 0, vr = 0, c = 0, vc = 0, v = 0, l = 0, ok = 0, m = 55;
                    string w = client.nextWord();
                    int lw = w.Length;
                    for (int j = 0; j < C; j++)
                    {
                        for (int i = 0; i < R; i++)
                        {
                            if (F[i, j] != '0')
                            {
                                if (v == 0) continue;
                                if (l < lw) { l = 0; continue; }
                                if (l < m) { m = l; r = vr; c = vc; v = 0; ok++; } l = 0;
                            }
                            else
                            {
                                if (v == 0) { vr = i; vc = j; v++; }
                                l++;
                            }
                        }
                        if (l < m && l >= lw) { m = l; r = vr; c = vc; ok++; }
                        v = 0; l = 0;
                    }
                    if (ok > 0)
                    {
                        for (int i = 0; i < lw; i++)
                        {
                            F[r + i, c] = w[i];
                        }
                    }
                    else err++;
                    client.placeWord(r, c, true);
                    if (timer.ElapsedMilliseconds > 9800) break;
                    if (err == 1) break;
                }
                long time = 0;
                client.EndGame(out time);
            }
        }
    }
}